unit DemoU;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  OleCtrls, isp3, ExtCtrls, StdCtrls, Buttons, ComCtrls,
  HtmlL;

type
  TParserDemoF = class(TForm)
    Panel1: TPanel;
    HTTP1: THTTP;
    Panel2: TPanel;
    BitBtn1: TBitBtn;
    PageControl1: TPageControl;
    FirstTS: TTabSheet;
    GoButton: TSpeedButton;
    CancelBtn: TSpeedButton;
    Memo1: TMemo;
    StatusBar1: TStatusBar;
    URLs: TComboBox;
    TabSheet2: TTabSheet;
    Panel3: TPanel;
    Memo2: TMemo;
    Label1: TLabel;
    TagsBB: TBitBtn;
    TabSheet3: TTabSheet;
    Panel4: TPanel;
    Panel5: TPanel;
    ParamBB: TBitBtn;
    Label2: TLabel;
    Memo3: TMemo;
    Panel6: TPanel;
    Panel7: TPanel;
    Memo4: TMemo;
    Label3: TLabel;
    SelParamE: TEdit;
    SelParamBB: TBitBtn;
    PairsCB: TCheckBox;
    TabSheet4: TTabSheet;
    Panel8: TPanel;
    HRefBB: TBitBtn;
    Memo5: TMemo;
    BaseUrlE: TEdit;
    Label4: TLabel;
    TabSheet5: TTabSheet;
    Label5: TLabel;
    UrlFunctCB: TComboBox;
    FunctBB: TBitBtn;
    GroupBox1: TGroupBox;
    UrlTypeE: TEdit;
    GroupBox2: TGroupBox;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    ProtFE: TEdit;
    DomFE: TEdit;
    DirFE: TEdit;
    DocFE: TEdit;
    Label10: TLabel;
    PorFE: TEdit;
    GroupBox3: TGroupBox;
    ExpUrlE: TEdit;
    ExpndUE: TEdit;
    TabSheet1: TTabSheet;
    Panel9: TPanel;
    Label11: TLabel;
    Label12: TLabel;
    Label13: TLabel;
    Label14: TLabel;
    Label15: TLabel;
    MyEmaSB: TSpeedButton;
    MyUrlSB: TSpeedButton;
    procedure CancelBtnClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure HTTP1DocOutput(Sender: TObject; const DocOutput: DocOutput);
    procedure GoButtonClick(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure TagsBBClick(Sender: TObject);
    procedure ParamBBClick(Sender: TObject);
    procedure SelParamBBClick(Sender: TObject);
    procedure HRefBBClick(Sender: TObject);
    procedure FunctBBClick(Sender: TObject);
    procedure MyUrlSBClick(Sender: TObject);
    procedure MyEmaSBClick(Sender: TObject);
  protected
    Parser, TmpParser : THtmlParser;
    FHtmlLoaded : boolean;

    procedure  SetHtmlLoaded( value : boolean);
  private
    property HtmlLoaded : boolean read FHtmlLoaded write SetHtmlLoaded;
  public
  end;

var
  ParserDemoF: TParserDemoF;

implementation
{$R *.DFM}
uses ShellAPI;

procedure TParserDemoF.FormCreate(Sender: TObject);
begin
  Parser := THtmlParser.Create;
  FHtmlLoaded := true; HtmlLoaded := false;
  PageControl1.ActivePage := FirstTS;
  FunctBBClick( FunctBB);
end;

procedure  TParserDemoF.SetHtmlLoaded( value : boolean);
begin
  if FHtmlLoaded = value then exit;
  FHtmlLoaded := value;
  TagsBB.Enabled := value;
  ParamBB.Enabled := value;
  SelParamBB.Enabled := value;
  HRefBB.Enabled := value;
{  FunctBB.Enabled := value;}
end;

procedure TParserDemoF.CancelBtnClick(Sender: TObject);
begin
  HTTP1.Cancel;
  CancelBtn.Enabled := False;
  GoButton.Enabled := true;
end;

procedure TParserDemoF.HTTP1DocOutput(Sender: TObject;
  const DocOutput: DocOutput);
var
  S: OleVariant;

  procedure LoadParser;
  var TmpStream : TStream;
  begin
    HtmlLoaded := false;
    Parser.Clear;
    TmpStream := TMemoryStream.Create;
    try
      Memo1.Lines.SaveToStream( TmpStream);
      TmpStream.Position := 0;
      Parser.LoadFromStream( TmpStream);
      Parser.BaseUrl := HTTP1.URL;
    finally
      TmpStream.Free;
      end;

    if Parser.Loaded then begin
      HtmlLoaded := true;
      BaseUrlE.Text := Parser.BaseUrl;
      Parser.HRefParameters( UrlFunctCB.Items);
      UrlFunctCB.Text := Parser.BaseUrl;
      end;
  end;

begin
  Statusbar1.Panels[2].Text := Format('Bytes: %d',[DocOutput.BytesTransferred]);
  case DocOutput.State of
    icDocBegin : begin
      Memo1.Lines.Clear;
      Memo2.Lines.Clear;
      Memo3.Lines.Clear;
      Memo4.Lines.Clear;
      Memo5.Lines.Clear;
      Statusbar1.Panels[1].Text := 'Start';
      end;
    icDocData : begin
      DocOutput.GetData(S, '');
      Memo1.Lines.Add( S);
      Statusbar1.Panels[1].Text := 'In progress';
      end;
    icDocEnd : begin
      Memo1.SelStart := 0;
      SendMessage(Memo1.Handle, EM_ScrollCaret, 0, 0);
      Statusbar1.Panels[1].Text := 'Complete';
      CancelBtn.Enabled := False;
      GoButton.Enabled := true;

      LoadParser; { Load parser from Memo1 lines stream}
      end;
  end;
  Refresh;
end;


procedure TParserDemoF.GoButtonClick(Sender: TObject);
var
  a,b: Olevariant;
begin
  HtmlLoaded := false;
  Memo1.Lines.Clear;
  if URLs.Items.IndexOf(URLs.Text) = -1 then
    URLs.Items.Add(URLs.Text);
  if HTTP1.Busy then
    HTTP1.Cancel;
  HTTP1.OleObject.GetDoc(URLs.text, a, b);
  Statusbar1.Panels[0].Text := HTTP1.URL;
  CancelBtn.Enabled := true;
  GoButton.Enabled := false;
end;


procedure TParserDemoF.FormDestroy(Sender: TObject);
begin
  Parser.Free;
end;

procedure TParserDemoF.TagsBBClick(Sender: TObject);
begin
  Memo2.Lines.Clear;
  Parser.Tags( Memo2.Lines);
  Memo2.SelStart := 0;
  SendMessage(Memo2.Handle, EM_ScrollCaret, 0, 0);
end;

procedure TParserDemoF.ParamBBClick(Sender: TObject);
begin
  Memo3.Lines.Clear;
  Parser.Parameters( Memo3.Lines);
  Memo3.SelStart := 0;
  SendMessage(Memo3.Handle, EM_ScrollCaret, 0, 0);
end;

procedure TParserDemoF.SelParamBBClick(Sender: TObject);
begin
  Memo4.Lines.Clear;
  Parser.SelectedParameters( SelParamE.Text, PairsCB.Checked, Memo4.Lines);
  Memo4.SelStart := 0;
  SendMessage(Memo4.Handle, EM_ScrollCaret, 0, 0);
end;

procedure TParserDemoF.HRefBBClick(Sender: TObject);
begin
  Memo5.Lines.Clear;
  Parser.HRefParameters( Memo5.Lines);
  Memo5.SelStart := 0;
  SendMessage( Memo5.Handle, EM_ScrollCaret, 0, 0);
end;

procedure TParserDemoF.FunctBBClick(Sender: TObject);
var
  TmpUrl, ProtS, DomS, PorS, DirS, DocS : string;
begin
  ProtFE.Text := '';
  DomFE.Text := '';
  PorFE.Text := '';
  DirFE.Text := '';
  DocFE.Text := '';
  ExpndUE.Text := '';

  TmpUrl := UrlFunctCB.Text;
  case UrlType( TmpUrl) of
    utUnknow   : UrlTypeE.Text := 'utUnknow';
    utHtmlLink : UrlTypeE.Text := 'utHtmlLink';
    utText     : UrlTypeE.Text := 'utText';
    utImage    : UrlTypeE.Text := 'utImage';
    utOther    : UrlTypeE.Text := 'utOther';
    else UrlTypeE.Text := '';
    end;
  if SplitUrl( TmpUrl, ProtS, DomS, PorS, DirS, DocS) then begin
    ProtFE.Text := ProtS;
    DomFE.Text := DomS;
    PorFE.Text := PorS;
    DirFE.Text := DirS;
    DocFE.Text := DocS;
    end;
  ExpndUE.Text := ExpandUrl( TmpUrl, ExpUrlE.Text);
end;

procedure TParserDemoF.MyUrlSBClick(Sender: TObject);
var TempString : array[0..79] of char;
begin
   StrPCopy( TempString, 'http://www.iberiapac.ge/~kochini/');
   ShellExecute(0, Nil, TempString, Nil, Nil, SW_NORMAL);
end;

procedure TParserDemoF.MyEmaSBClick(Sender: TObject);
var TempString : array[0..79] of char;
begin
   StrPCopy( TempString, 'mailto:kochini@iberiapac.ge');
   ShellExecute(0, Nil, TempString, Nil, Nil, SW_NORMAL);
end;

end.
